import java.util.Iterator;
import java.util.*;

public abstract class TestTree {

        
    public static void main(String[] args) {
        ArrayList<DecorationFactory> factories = new ArrayList<DecorationFactory>();
        
        DecorationFactory sf= new StarFactory();
        DecorationFactory rif= new RibbonFactory();
        DecorationFactory ruf= new RuffleFactory();
        
        factories.add(sf);
        factories.add(rif);
        factories.add(ruf);
        factories.add(rif);
        factories.add(ruf);
        
        Iterator i = factories.iterator();
        Tree myTree = build(5);
        
        //TBF
        myTree = myTree.decorateYourself(i, new RibbonFactory());
        printTree(myTree);
    }
        
    public static Tree build(int levels){
        levels--;
        Tree t = new Node(new Leaf(), Math.pow(2,levels)-1);
        levels--;
        while(levels>=0){
            t= new Node(t, Math.pow(2,levels));
            levels--;
        }
        return t;
    }

     public static void printTree(Tree tree) {
        System.out.println(tree.getDescription());
        System.out.println( " costs " + "$" + tree.getCost());
    }
   
 }
